/**
 * Adds a style when a property is present
 * <Box top />
 * @param mixin
 */
export declare const toggle: (mixin: any) => (val: any) => any;
/**
 * Maps string values to styles
 * <Box alignItems="center" />
 * @param map
 */
export declare const mapping: (map: any) => (val: any) => any;
/**
 * Maps a range of integers to a range of classnames
 * <Box padding={1} />
 * @param scale
 * @param breakpoint
 */
export declare const range: (scale: any, breakpoint: any) => (n: any) => any;
/**
 * Like `range`, maps a range of integers to a range of classnames, excluding
 * zero values.
 * <Box padding={1} />
 * @param scale
 * @param breakpoint
 */
/**
 * Create a range only if the value is not zero.
 */
export declare const rangeWithoutZero: (scale: any, breakpoint?: string | undefined) => (n: any) => any;
/**
 * This takes a series of the previously defined functors, runs them all against
 * a value and returns the set of their classnames.
 * @param fns
 */
export declare const union: (...fns: any) => (val: any) => never[];
//# sourceMappingURL=transform.helper.d.ts.map