'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var _extends = _interopDefault(require('@babel/runtime-corejs2/helpers/extends'));
var _taggedTemplateLiteral = _interopDefault(require('@babel/runtime-corejs2/helpers/taggedTemplateLiteral'));
var MUITextField = _interopDefault(require('@material-ui/core/TextField'));
var React = require('react');
var styled = require('styled-components');
var styled__default = _interopDefault(styled);
var Button = _interopDefault(require('@material-ui/core/Button'));
var MUIRadio = _interopDefault(require('@material-ui/core/Radio'));
var _objectWithoutProperties = _interopDefault(require('@babel/runtime-corejs2/helpers/objectWithoutProperties'));
var FormControl = _interopDefault(require('@material-ui/core/FormControl'));
var FormControlLabel = _interopDefault(require('@material-ui/core/FormControlLabel'));
var FormHelperText = require('@material-ui/core/FormHelperText');
var FormHelperText__default = _interopDefault(FormHelperText);
var FormLabel = require('@material-ui/core/FormLabel');
var FormLabel__default = _interopDefault(FormLabel);
var RadioGroup = require('@material-ui/core/RadioGroup');
var RadioGroup__default = _interopDefault(RadioGroup);
var recompose = require('recompose');
var lodashEs = require('lodash-es');

function _templateObject2() {
  var data = _taggedTemplateLiteral(["\n  && {\n    margin-top: 0px;\n    margin-bottom: 16px;\n\n    // FORM HELPER TEXT\n\n    & .FormHelperText-root {\n      min-height: 20px;\n      font-family: 'gordita', sans-serif;\n      color: #737373;\n      font-size: 12px;\n      line-height: 20px;\n      font-weight: 400;\n      margin-top: 4px;\n    }\n\n    & .FormHelperText-error {\n    }\n\n    & .FormHelperText-root.FormHelperText-error {\n      color: #ec0000;\n      animation-name: ", ";\n      animation-timing-function: ease-in-out;\n      animation-duration: 0.8s;\n      animation-delay: 0;\n    }\n\n    // INPUT\n\n    & .Input-root {\n      font-family: 'gordita', sans-serif;\n      border-top-left-radius: 0px;\n      border-top-right-radius: 0px;\n      background-color: rgba(0, 0, 0, 0.05490196078431373);\n      &:hover {\n        background-color: rgba(0, 0, 0, 0.08235294117647058);\n      }\n\n      &:before {\n        border-bottom: 1px solid rgba(0, 0, 0, 0.29045643153526974);\n      }\n    }\n\n    & .Input-input {\n      font-size: 16px;\n      line-height: 24px;\n      color: #505050;\n      padding-top: 24px;\n      padding-bottom: 8px;\n    }\n\n    & .Input-disabled {\n    }\n\n    & .Input-focused {\n    }\n\n    & .Input-error {\n    }\n\n    // INPUT UNDERLINE\n\n    & .Input-underline {\n      &:hover:not(.Input-disabled):not(.Input-focused):not(.Input-error):before {\n        border-bottom: 1px solid rgba(0, 0, 0, 0.5085470085470085);\n      }\n      &:after {\n        border-bottom: 2px solid #3f75c6;\n      }\n    }\n\n    & .Input-underline.Input-error {\n      &:after {\n        border-bottom: 2px solid #ec0000;\n      }\n    }\n\n    // INPUT LABEL\n\n    & .InputLabel-root {\n      font-family: 'gordita', sans-serif;\n      font-size: 16px;\n      line-height: 24px;\n      color: #666;\n      transform: translate(12px, 16px) scale(1);\n    }\n\n    & .InputLabel-shrink.InputLabel-error {\n      color: #ec0000;\n    }\n\n    & .InputLabel-shrink {\n      transform: translate(12px, 8px) scale(0.75);\n    }\n  }\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  0% {\n     transform: translateX(0);\n   }\n   6.5% {\n     transform: translateX(-6px) rotateY(-9deg);\n   }\n   18.5% {\n     transform: translateX(5px) rotateY(7deg);\n   }\n   31.5% {\n     transform: translateX(-3px) rotateY(-5deg);\n   }\n   43.5% {\n     transform: translateX(2px) rotateY(3deg);\n   }\n   50% {\n     transform: translateX(0);\n   }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}
var headShake = styled.keyframes(_templateObject());
var TextField = styled__default(function (props) {
  return React.createElement(MUITextField, _extends({}, props, {
    helperText: props.helperText ? props.helperText : '\n',
    classes: {
      root: 'TextField-root',
      fullWidth: 'TextField-fullWidth',
      marginDense: 'TextField-marginDense',
      marginNormal: 'TextField-marginNormal'
    },
    margin: "normal",
    variant: "filled",
    FormHelperTextProps: {
      required: true,
      classes: {
        contained: 'FormHelperText-contained',
        disabled: 'FormHelperText-contained',
        error: 'FormHelperText-error',
        filled: 'FormHelperText-filled',
        focused: 'FormHelperText-focused',
        marginDense: 'FormHelperText-marginDense',
        required: 'FormHelperText-required',
        root: 'FormHelperText-root'
      }
    },
    InputLabelProps: {
      classes: {
        animated: 'InputLabel-animated',
        disabled: 'InputLabel-disabled',
        error: 'InputLabel-error',
        filled: 'InputLabel-filled',
        focused: 'InputLabel-focused',
        formControl: 'InputLabel-formControl',
        marginDense: 'InputLabel-marginDense',
        outlined: 'InputLabel-outlined',
        required: 'InputLabel-required',
        root: 'InputLabel-root',
        shrink: 'InputLabel-shrink'
      }
    },
    InputProps: {
      classes: {
        adornedEnd: 'Input-adornedEnd',
        adornedStart: 'Input-adornedStart',
        disabled: 'Input-disabled',
        error: 'Input-error',
        focused: 'Input-focused',
        input: 'Input-input',
        inputAdornedEnd: 'Input-inputAdornedEnd',
        inputAdornedStart: 'Input-inputAdornedStart',
        inputMarginDense: 'Input-inputMarginDense',
        inputMultiline: 'Input-inputMultiline',
        multiline: 'Input-multiline',
        root: 'Input-root',
        underline: 'Input-underline'
      }
    },
    SelectProps: {
      classes: {
        disabled: 'Select-disabled',
        filled: 'Select-filled',
        outlined: 'Select-outlined',
        icon: 'Select-icon',
        root: 'Select-root',
        select: 'Select-select',
        selectMenu: 'Select-selectMenu'
      }
    }
  }));
})(_templateObject2(), headShake);

function _templateObject$1() {
  var data = _taggedTemplateLiteral(["\n  && {\n  }\n"]);

  _templateObject$1 = function _templateObject() {
    return data;
  };

  return data;
}
var SelectFieldNative = styled__default(function (props) {
  return React.createElement(TextField, _extends({}, props, {
    select: true,
    SelectProps: {
      native: true,
      MenuProps: {// className: classes.menu
      }
    }
  }), props.options.map(function (option) {
    return React.createElement("option", {
      key: option.value,
      value: option.value
    }, option.label);
  }));
})(_templateObject$1());

function _templateObject$2() {
  var data = _taggedTemplateLiteral(["\n  && {\n    svg {\n      font-size: 20px;\n    }\n    &.Radio-root {\n      padding: 10px;\n      color: ", ";\n      &:hover:not(.Radio-checked) {\n        border-radius: 50%;\n        background: rgba(0, 0, 0, 0.05490196078431373);\n      }\n    }\n\n    &.Radio-checked {\n    }\n    &.Radio-colorPrimary {\n    }\n    &.Radio-colorSecondary {\n    }\n    &.Radio-colorSecondary.Radio-checked {\n      color: #ffb432;\n    }\n    &.Radio-colorSecondary.Radio-disabled {\n      color: ", ";\n    }\n    &.Radio-disabled {\n    }\n  }\n"]);

  _templateObject$2 = function _templateObject() {
    return data;
  };

  return data;
}
var Radio = styled__default(MUIRadio).attrs({
  classes: {
    root: 'Radio-root',
    checked: 'Radio-checked',
    colorPrimary: 'Radio-colorPrimary',
    colorSecondary: 'Radio-colorSecondary',
    disabled: 'Radio-disabled'
  }
})(_templateObject$2(), function (_ref) {
  var error = _ref.error;
  return error ? '#ec0000' : 'rgba(0, 0, 0, 0.55)';
}, function (_ref2) {
  var error = _ref2.error;
  return error ? 'rgba(236, 0, 0, 0.16)' : 'rgba(0, 0, 0, 0.11)';
});
Radio.defaultProps = {
  'data-id': 'radio'
};

function handleChange(_ref) {
  var setState = _ref.setState;
  return function (event) {
    setState(function () {
      return {
        value: event.target.value
      };
    });
  };
}

var name = 'state';
var updaterName = 'setState';
function initialState() {
  return {
    value: ''
  };
}

function _templateObject$3() {
  var data = _taggedTemplateLiteral(["\n  && {\n  }\n"]);

  _templateObject$3 = function _templateObject() {
    return data;
  };

  return data;
}
var RadioGroupFieldInner = styled__default(function (_ref) {
  var handleChange$$1 = _ref.handleChange,
      state = _ref.state,
      helperTextId = _ref.helperTextId,
      className = _ref.className,
      error = _ref.error,
      fullWidth = _ref.fullWidth,
      required = _ref.required,
      label = _ref.label,
      FormLabelProps = _ref.FormLabelProps,
      id = _ref.id,
      onBlur = _ref.onBlur,
      onChange = _ref.onChange,
      onFocus = _ref.onFocus,
      value = _ref.value,
      name$$1 = _ref.name,
      placeholder = _ref.placeholder,
      RadioGroupProps = _ref.RadioGroupProps,
      helperText = _ref.helperText,
      FormHelperTextProps = _ref.FormHelperTextProps,
      other = _objectWithoutProperties(_ref, ["handleChange", "state", "helperTextId", "className", "error", "fullWidth", "required", "label", "FormLabelProps", "id", "onBlur", "onChange", "onFocus", "value", "name", "placeholder", "RadioGroupProps", "helperText", "FormHelperTextProps"]);

  return React.createElement(FormControl, _extends({
    "aria-describedby": helperTextId,
    className: className,
    error: error,
    fullWidth: fullWidth,
    required: required,
    variant: "standard"
  }, other), label && React.createElement(FormLabel__default, _extends({
    htmlFor: id
  }, FormLabelProps), label), React.createElement(RadioGroup__default, _extends({
    id: id,
    onFocus: onFocus,
    onBlur: onBlur,
    onChange: onChange,
    value: value,
    name: name$$1,
    placeholder: placeholder
  }, RadioGroupProps), React.createElement(FormControlLabel, {
    value: "female",
    control: React.createElement(Radio, null),
    label: "Female"
  }), React.createElement(FormControlLabel, {
    value: "male",
    control: React.createElement(Radio, null),
    label: "Male"
  }), React.createElement(FormControlLabel, {
    value: "other",
    control: React.createElement(Radio, null),
    label: "Other"
  }), React.createElement(FormControlLabel, {
    value: "disabled",
    disabled: true,
    control: React.createElement(Radio, {
      error: error
    }),
    label: "(Disabled option)"
  })), helperText && React.createElement(FormHelperText__default, _extends({
    id: helperTextId
  }, FormHelperTextProps), helperText));
})(_templateObject$3());
var handlers = {
  handleChange: handleChange
}; // TODO: move to @origin-digital/recompose

var omitProps = function omitProps(keys) {
  return recompose.mapProps(function (props) {
    return lodashEs.omit(props, keys);
  });
};

var enhance = recompose.compose(recompose.withProps(console.log), recompose.withState(name, updaterName, initialState), recompose.withHandlers(handlers), omitProps('setState'), recompose.withProps(console.log));
var RadioGroupField = enhance(RadioGroupFieldInner);

var BREAK_POINTS = {
  /*
    Extra small devices (portrait phones, less than 544px)
    No media query since this is the default at Origin because we are "mobile first"
    */
  Min: {
    /* Small devices (landscape phones, 544px and up) */
    SM: '576px',

    /* Medium devices (tablets, 768px and up) The navbar toggle appears at this breakpoint */
    MD: '768px',

    /* Large devices (desktops, 992px and up) */
    LG: '992px',

    /* Extra large devices (large desktops, 1200px and up) */
    XL: '1200px'
  },
  Max: {
    SM: '575px',
    MD: '767px',
    LG: '991px',
    XL: '1199px'
  }
};

function _templateObject4() {
  var data = _taggedTemplateLiteral(["\n    @media only screen and (min-width: ", ") {\n      ", ";\n    }\n  "]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = _taggedTemplateLiteral(["\n    @media only screen and (min-width: ", ") {\n      ", ";\n    }\n  "]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2$1() {
  var data = _taggedTemplateLiteral(["\n    @media only screen and (min-width: ", ") {\n      ", ";\n    }\n  "]);

  _templateObject2$1 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject$4() {
  var data = _taggedTemplateLiteral(["\n    @media only screen and (min-width: ", ") {\n      ", ";\n    }\n  "]);

  _templateObject$4 = function _templateObject() {
    return data;
  };

  return data;
}
var styledCss = styled.css;
var media = {
  SM: function SM() {
    return styledCss(_templateObject$4(), BREAK_POINTS.Min.SM, styledCss.apply(void 0, arguments));
  },
  MD: function MD() {
    return styled.css(_templateObject2$1(), BREAK_POINTS.Min.MD, styledCss.apply(void 0, arguments));
  },

  /* Large devices (desktops, 992px and up) */
  LG: function LG() {
    return styled.css(_templateObject3(), BREAK_POINTS.Min.LG, styledCss.apply(void 0, arguments));
  },

  /* Extra large devices (large desktops, 1200px and up) */
  XL: function XL() {
    return styled.css(_templateObject4(), BREAK_POINTS.Min.XL, styledCss.apply(void 0, arguments));
  }
};

function _templateObject63() {
  var data = _taggedTemplateLiteral(["\n    ", " ", ";\n  "]);

  _templateObject63 = function _templateObject63() {
    return data;
  };

  return data;
}

function _templateObject62() {
  var data = _taggedTemplateLiteral(["\n  border: 0;\n"]);

  _templateObject62 = function _templateObject62() {
    return data;
  };

  return data;
}

function _templateObject61() {
  var data = _taggedTemplateLiteral(["\n  border-radius: ", " 0 0 ", ";\n"]);

  _templateObject61 = function _templateObject61() {
    return data;
  };

  return data;
}

function _templateObject60() {
  var data = _taggedTemplateLiteral(["\n  border-radius: 0 0 ", " ", ";\n"]);

  _templateObject60 = function _templateObject60() {
    return data;
  };

  return data;
}

function _templateObject59() {
  var data = _taggedTemplateLiteral(["\n  border-radius: 0 ", " ", " 0;\n"]);

  _templateObject59 = function _templateObject59() {
    return data;
  };

  return data;
}

function _templateObject58() {
  var data = _taggedTemplateLiteral(["\n  border-radius: ", " ", " 0 0;\n"]);

  _templateObject58 = function _templateObject58() {
    return data;
  };

  return data;
}

function _templateObject57() {
  var data = _taggedTemplateLiteral(["\n  border-radius: ", ";\n"]);

  _templateObject57 = function _templateObject57() {
    return data;
  };

  return data;
}

function _templateObject56() {
  var data = _taggedTemplateLiteral(["\n  border-radius: 999px;\n"]);

  _templateObject56 = function _templateObject56() {
    return data;
  };

  return data;
}

function _templateObject55() {
  var data = _taggedTemplateLiteral(["\n  border-radius: 50%;\n"]);

  _templateObject55 = function _templateObject55() {
    return data;
  };

  return data;
}

function _templateObject54() {
  var data = _taggedTemplateLiteral(["\n  border-radius: 0;\n"]);

  _templateObject54 = function _templateObject54() {
    return data;
  };

  return data;
}

function _templateObject53() {
  var data = _taggedTemplateLiteral(["\n  border-left: ", " solid ", ";\n"]);

  _templateObject53 = function _templateObject53() {
    return data;
  };

  return data;
}

function _templateObject52() {
  var data = _taggedTemplateLiteral(["\n  border-bottom: ", " solid ", ";\n"]);

  _templateObject52 = function _templateObject52() {
    return data;
  };

  return data;
}

function _templateObject51() {
  var data = _taggedTemplateLiteral(["\n  border-right: ", " solid ", ";\n"]);

  _templateObject51 = function _templateObject51() {
    return data;
  };

  return data;
}

function _templateObject50() {
  var data = _taggedTemplateLiteral(["\n  border-top: ", " solid ", ";\n"]);

  _templateObject50 = function _templateObject50() {
    return data;
  };

  return data;
}

function _templateObject49() {
  var data = _taggedTemplateLiteral(["\n  border: ", " solid ", ";\n"]);

  _templateObject49 = function _templateObject49() {
    return data;
  };

  return data;
}

function _templateObject48() {
  var data = _taggedTemplateLiteral(["\n        ", ""]);

  _templateObject48 = function _templateObject48() {
    return data;
  };

  return data;
}

function _templateObject47() {
  var data = _taggedTemplateLiteral(["\n      padding-bottom: calc(", " * ", ");\n      padding-top: calc(", " * ", ");\n    "]);

  _templateObject47 = function _templateObject47() {
    return data;
  };

  return data;
}

function _templateObject46() {
  var data = _taggedTemplateLiteral(["\n        ", ""]);

  _templateObject46 = function _templateObject46() {
    return data;
  };

  return data;
}

function _templateObject45() {
  var data = _taggedTemplateLiteral(["\n      padding-left: calc(", " * ", ");\n      padding-right: calc(", " * ", ");\n    "]);

  _templateObject45 = function _templateObject45() {
    return data;
  };

  return data;
}

function _templateObject44() {
  var data = _taggedTemplateLiteral(["\n        ", ""]);

  _templateObject44 = function _templateObject44() {
    return data;
  };

  return data;
}

function _templateObject43() {
  var data = _taggedTemplateLiteral(["\n      margin-left: calc(", " * ", ");\n    "]);

  _templateObject43 = function _templateObject43() {
    return data;
  };

  return data;
}

function _templateObject42() {
  var data = _taggedTemplateLiteral(["\n        ", ""]);

  _templateObject42 = function _templateObject42() {
    return data;
  };

  return data;
}

function _templateObject41() {
  var data = _taggedTemplateLiteral(["\n      margin-bottom: calc(", " * ", ");\n    "]);

  _templateObject41 = function _templateObject41() {
    return data;
  };

  return data;
}

function _templateObject40() {
  var data = _taggedTemplateLiteral(["\n        ", ""]);

  _templateObject40 = function _templateObject40() {
    return data;
  };

  return data;
}

function _templateObject39() {
  var data = _taggedTemplateLiteral(["\n      margin-right: calc(", " * ", ");\n    "]);

  _templateObject39 = function _templateObject39() {
    return data;
  };

  return data;
}

function _templateObject38() {
  var data = _taggedTemplateLiteral(["\n        ", ""]);

  _templateObject38 = function _templateObject38() {
    return data;
  };

  return data;
}

function _templateObject37() {
  var data = _taggedTemplateLiteral(["\n      margin-top: calc(", " * ", ");\n    "]);

  _templateObject37 = function _templateObject37() {
    return data;
  };

  return data;
}

function _templateObject36() {
  var data = _taggedTemplateLiteral(["\n            ", "\n        "]);

  _templateObject36 = function _templateObject36() {
    return data;
  };

  return data;
}

function _templateObject35() {
  var data = _taggedTemplateLiteral(["\n      width: calc(", " / ", " * 100%);\n    "]);

  _templateObject35 = function _templateObject35() {
    return data;
  };

  return data;
}

function _templateObject34() {
  var data = _taggedTemplateLiteral(["\n    cursor: ", ";\n  "]);

  _templateObject34 = function _templateObject34() {
    return data;
  };

  return data;
}

function _templateObject33() {
  var data = _taggedTemplateLiteral(["\n    max-width: ", ";\n  "]);

  _templateObject33 = function _templateObject33() {
    return data;
  };

  return data;
}

function _templateObject32() {
  var data = _taggedTemplateLiteral(["\n    min-width: ", ";\n  "]);

  _templateObject32 = function _templateObject32() {
    return data;
  };

  return data;
}

function _templateObject31() {
  var data = _taggedTemplateLiteral(["\n    width: ", ";\n  "]);

  _templateObject31 = function _templateObject31() {
    return data;
  };

  return data;
}

function _templateObject30() {
  var data = _taggedTemplateLiteral(["\n    max-height: ", ";\n  "]);

  _templateObject30 = function _templateObject30() {
    return data;
  };

  return data;
}

function _templateObject29() {
  var data = _taggedTemplateLiteral(["\n    min-height: ", ";\n  "]);

  _templateObject29 = function _templateObject29() {
    return data;
  };

  return data;
}

function _templateObject28() {
  var data = _taggedTemplateLiteral(["\n    height: ", ";\n  "]);

  _templateObject28 = function _templateObject28() {
    return data;
  };

  return data;
}

function _templateObject27() {
  var data = _taggedTemplateLiteral(["\n  max-width: 100%;\n"]);

  _templateObject27 = function _templateObject27() {
    return data;
  };

  return data;
}

function _templateObject26() {
  var data = _taggedTemplateLiteral(["\n  overflow: auto;\n"]);

  _templateObject26 = function _templateObject26() {
    return data;
  };

  return data;
}

function _templateObject25() {
  var data = _taggedTemplateLiteral(["\n  overflow-x: hidden;\n  overflow-y: scroll;\n"]);

  _templateObject25 = function _templateObject25() {
    return data;
  };

  return data;
}

function _templateObject24() {
  var data = _taggedTemplateLiteral(["\n  overflow-x: scroll;\n  overflow-y: hidden;\n"]);

  _templateObject24 = function _templateObject24() {
    return data;
  };

  return data;
}

function _templateObject23() {
  var data = _taggedTemplateLiteral(["\n  overflow: scroll;\n"]);

  _templateObject23 = function _templateObject23() {
    return data;
  };

  return data;
}

function _templateObject22() {
  var data = _taggedTemplateLiteral(["\n  overflow: hidden;\n"]);

  _templateObject22 = function _templateObject22() {
    return data;
  };

  return data;
}

function _templateObject21() {
  var data = _taggedTemplateLiteral(["\n  position: relative;\n  position: sticky;\n"]);

  _templateObject21 = function _templateObject21() {
    return data;
  };

  return data;
}

function _templateObject20() {
  var data = _taggedTemplateLiteral(["\n  position: fixed;\n"]);

  _templateObject20 = function _templateObject20() {
    return data;
  };

  return data;
}

function _templateObject19() {
  var data = _taggedTemplateLiteral(["\n  position: relative;\n"]);

  _templateObject19 = function _templateObject19() {
    return data;
  };

  return data;
}

function _templateObject18() {
  var data = _taggedTemplateLiteral(["\n  position: absolute;\n"]);

  _templateObject18 = function _templateObject18() {
    return data;
  };

  return data;
}

function _templateObject17() {
  var data = _taggedTemplateLiteral(["\n  left: 0;\n"]);

  _templateObject17 = function _templateObject17() {
    return data;
  };

  return data;
}

function _templateObject16() {
  var data = _taggedTemplateLiteral(["\n  bottom: 0;\n"]);

  _templateObject16 = function _templateObject16() {
    return data;
  };

  return data;
}

function _templateObject15() {
  var data = _taggedTemplateLiteral(["\n  right: 0;\n"]);

  _templateObject15 = function _templateObject15() {
    return data;
  };

  return data;
}

function _templateObject14() {
  var data = _taggedTemplateLiteral(["\n  top: 0;\n"]);

  _templateObject14 = function _templateObject14() {
    return data;
  };

  return data;
}

function _templateObject13() {
  var data = _taggedTemplateLiteral(["\n  order: 99999;\n"]);

  _templateObject13 = function _templateObject13() {
    return data;
  };

  return data;
}

function _templateObject12() {
  var data = _taggedTemplateLiteral(["\n  order: -1;\n"]);

  _templateObject12 = function _templateObject12() {
    return data;
  };

  return data;
}

function _templateObject11() {
  var data = _taggedTemplateLiteral(["\n  flex-wrap: wrap;\n"]);

  _templateObject11 = function _templateObject11() {
    return data;
  };

  return data;
}

function _templateObject10() {
  var data = _taggedTemplateLiteral(["\n  flex: 0 0 auto;\n"]);

  _templateObject10 = function _templateObject10() {
    return data;
  };

  return data;
}

function _templateObject9() {
  var data = _taggedTemplateLiteral(["\n  flex: 1 1 auto;\n\n  /* 1 */\n  min-height: 0;\n  min-width: 0;\n"]);

  _templateObject9 = function _templateObject9() {
    return data;
  };

  return data;
}

function _templateObject8() {
  var data = _taggedTemplateLiteral(["\n    justify-content: ", ";\n  "]);

  _templateObject8 = function _templateObject8() {
    return data;
  };

  return data;
}

function _templateObject7() {
  var data = _taggedTemplateLiteral(["\n    align-self: ", ";\n  "]);

  _templateObject7 = function _templateObject7() {
    return data;
  };

  return data;
}

function _templateObject6() {
  var data = _taggedTemplateLiteral(["\n    align-items: ", ";\n  "]);

  _templateObject6 = function _templateObject6() {
    return data;
  };

  return data;
}

function _templateObject5() {
  var data = _taggedTemplateLiteral(["\n    align-content: ", ";\n  "]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4$1() {
  var data = _taggedTemplateLiteral(["\n            ", ""]);

  _templateObject4$1 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3$1() {
  var data = _taggedTemplateLiteral(["\n      flex-direction: ", ";\n    "]);

  _templateObject3$1 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2$2() {
  var data = _taggedTemplateLiteral(["\n            ", ""]);

  _templateObject2$2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject$5() {
  var data = _taggedTemplateLiteral(["\n      display: ", ";\n    "]);

  _templateObject$5 = function _templateObject() {
    return data;
  };

  return data;
}
var VERTICAL_RHYTHM = '4px'; // TODO: https://origindd.atlassian.net/browse/SAT-31
// Create breakpoint constants and use them in exisiting components

function display(breakpoint) {
  if (breakpoint && !BREAK_POINTS.Min[breakpoint]) {
    throw Error("Breakpoints must be SM, MD, LG or XL");
  }

  return function (value) {
    var c = styled.css(_templateObject$5(), value);
    return breakpoint ? media[breakpoint](_templateObject2$2(), c) : c;
  };
}
function direction(breakpoint) {
  if (breakpoint && !BREAK_POINTS.Min[breakpoint]) {
    throw Error("Breakpoints must be SM, MD, LG or XL");
  }

  return function (value) {
    var c = styled.css(_templateObject3$1(), value);
    return breakpoint ? media[breakpoint](_templateObject4$1(), c) : c;
  };
}
function alignContent(value) {
  return styled.css(_templateObject5(), value);
}
function alignItems(value) {
  return styled.css(_templateObject6(), value);
}
function alignSelf(value) {
  return styled.css(_templateObject7(), value);
}
function justifyContent(value) {
  return styled.css(_templateObject8(), value);
}
/* Fix for Chrome 44 bug: https://code.google.com/p/chromium/issues/detail?id=506893 */

var flexGrow = styled.css(_templateObject9());
var flexNone = styled.css(_templateObject10());
var flexWrap = styled.css(_templateObject11());
var orderFirst = styled.css(_templateObject12());
var orderLast = styled.css(_templateObject13());
var top0 = styled.css(_templateObject14());
var right0 = styled.css(_templateObject15());
var bottom0 = styled.css(_templateObject16());
var left0 = styled.css(_templateObject17());
/* position */

var absolute = styled.css(_templateObject18());
var relative = styled.css(_templateObject19());
var fixed = styled.css(_templateObject20());
/*
IE11 Fallback: when sticky is not supported, fall back to relative positioning.
We do this so if there is a zIndex set on sticky, the stacking context will be correct
*/

var sticky = styled.css(_templateObject21());
/* overflow */

var overflowHidden = styled.css(_templateObject22());
var overflowScroll = styled.css(_templateObject23());
var overflowScrollX = styled.css(_templateObject24());
var overflowScrollY = styled.css(_templateObject25());
var overflowAuto = styled.css(_templateObject26());
var fit = styled.css(_templateObject27()); // TODO: strings that are not %100 should convert to numbers with units.

/**
 * This is a copy of the dangerousStyleValue function from react-dom.
 * This function is no longer exported in React 16.x
 */

function dangerousStyleValue(name, value) {
  var isCustomProperty = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

  /**
   * CSS properties which accept numbers but are not in units of "px".
   */
  var isUnitlessNumber = {
    animationIterationCount: true,
    borderImageOutset: true,
    borderImageSlice: true,
    borderImageWidth: true,
    boxFlex: true,
    boxFlexGroup: true,
    boxOrdinalGroup: true,
    columnCount: true,
    columns: true,
    flex: true,
    flexGrow: true,
    flexPositive: true,
    flexShrink: true,
    flexNegative: true,
    flexOrder: true,
    gridRow: true,
    gridRowEnd: true,
    gridRowSpan: true,
    gridRowStart: true,
    gridColumn: true,
    gridColumnEnd: true,
    gridColumnSpan: true,
    gridColumnStart: true,
    fontWeight: true,
    lineClamp: true,
    lineHeight: true,
    opacity: true,
    order: true,
    orphans: true,
    tabSize: true,
    widows: true,
    zIndex: true,
    zoom: true,
    // SVG-related properties
    fillOpacity: true,
    floodOpacity: true,
    stopOpacity: true,
    strokeDasharray: true,
    strokeDashoffset: true,
    strokeMiterlimit: true,
    strokeOpacity: true,
    strokeWidth: true
  };
  var isEmpty = value == null || typeof value === 'boolean' || value === '';

  if (isEmpty) {
    return '';
  }

  if (!isCustomProperty && typeof value === 'number' && value !== 0 && !(isUnitlessNumber.hasOwnProperty(name) && isUnitlessNumber[name])) {
    return value + 'px'; // Presumes implicit 'px' suffix for unitless numbers
  }

  return ('' + value).trim();
}
function height(value) {
  return styled.css(_templateObject28(), dangerousStyleValue('height', value));
}
function minHeight(value) {
  return styled.css(_templateObject29(), dangerousStyleValue('minHeight', value));
}
function maxHeight(value) {
  return styled.css(_templateObject30(), dangerousStyleValue('maxHeight', value));
}
function width(value) {
  return styled.css(_templateObject31(), dangerousStyleValue('width', value));
}
function minWidth(value) {
  return styled.css(_templateObject32(), dangerousStyleValue('minWidth', value));
}
function maxWidth(value) {
  return styled.css(_templateObject33(), dangerousStyleValue('maxWidth', value));
}
function cursor(value) {
  return styled.css(_templateObject34(), value);
}
function column(breakpoint) {
  if (breakpoint && !BREAK_POINTS.Min[breakpoint]) {
    throw Error("Breakpoints must be SM, MD, LG or XL");
  }

  return function (value) {
    var ncols = 12;
    var c = styled.css(_templateObject35(), value, ncols);

    if (breakpoint) {
      return media[breakpoint](_templateObject36(), c);
    } else {
      return c;
    }
  };
}
function marginTop(breakpoint) {
  if (breakpoint && !BREAK_POINTS.Min[breakpoint]) {
    throw new Error("Breakpoints must be SM, MD, LG or XL");
  }

  return function (value) {
    var c = styled.css(_templateObject37(), VERTICAL_RHYTHM, value);
    return breakpoint ? media[breakpoint](_templateObject38(), c) : c;
  };
}
function marginRight(breakpoint) {
  if (breakpoint && !BREAK_POINTS.Min[breakpoint]) {
    throw Error("Breakpoints must be SM, MD, LG or XL");
  }

  return function (value) {
    var c = styled.css(_templateObject39(), VERTICAL_RHYTHM, value);
    return breakpoint ? media[breakpoint](_templateObject40(), c) : c;
  };
}
function marginBottom(breakpoint) {
  if (breakpoint && !BREAK_POINTS.Min[breakpoint]) {
    throw Error("Breakpoints must be SM, MD, LG or XL");
  }

  return function (value) {
    var c = styled.css(_templateObject41(), VERTICAL_RHYTHM, value);
    return breakpoint ? media[breakpoint](_templateObject42(), c) : c;
  };
}
function marginLeft(breakpoint) {
  if (breakpoint && !BREAK_POINTS.Min[breakpoint]) {
    throw Error("Breakpoints must be SM, MD, LG or XL");
  }

  return function (value) {
    var c = styled.css(_templateObject43(), VERTICAL_RHYTHM, value);
    return breakpoint ? media[breakpoint](_templateObject44(), c) : c;
  };
}
function paddingX(breakpoint) {
  if (breakpoint && !BREAK_POINTS.Min[breakpoint]) {
    throw Error("Breakpoints must be SM, MD, LG or XL");
  }

  return function (value) {
    var c = styled.css(_templateObject45(), VERTICAL_RHYTHM, value, VERTICAL_RHYTHM, value);
    return breakpoint ? media[breakpoint](_templateObject46(), c) : c;
  };
}
function paddingY(breakpoint) {
  if (breakpoint && !BREAK_POINTS.Min[breakpoint]) {
    throw Error("Breakpoints must be SM, MD, LG or XL");
  }

  return function (value) {
    var c = styled.css(_templateObject47(), VERTICAL_RHYTHM, value, VERTICAL_RHYTHM, value);
    return breakpoint ? media[breakpoint](_templateObject48(), c) : c;
  };
}
var borderWidth = 1;
var borderColor = '#efefef';
var borderRadius = '8px';
/* Border lines */

var border = styled.css(_templateObject49(), borderWidth, borderColor);
var borderTop = styled.css(_templateObject50(), borderWidth, borderColor);
var borderRight = styled.css(_templateObject51(), borderWidth, borderColor);
var borderBottom = styled.css(_templateObject52(), borderWidth, borderColor);
var borderLeft = styled.css(_templateObject53(), borderWidth, borderColor);
/* Border radii */

var square = styled.css(_templateObject54());
var circle = styled.css(_templateObject55());
var pill = styled.css(_templateObject56());
var rounded = styled.css(_templateObject57(), borderRadius);
var roundedTop = styled.css(_templateObject58(), borderRadius, borderRadius);
var roundedRight = styled.css(_templateObject59(), borderRadius, borderRadius);
var roundedBottom = styled.css(_templateObject60(), borderRadius, borderRadius);
var roundedLeft = styled.css(_templateObject61(), borderRadius, borderRadius);
var noBorder = styled.css(_templateObject62());
var breakpointStyle = function breakpointStyle(breakpoint) {
  return function (value) {
    if (!value) {
      return '';
    }

    return styled.css(_templateObject63(), value.column ? column(breakpoint)(value.column) : '', typeof value.display !== 'undefined' ? display(breakpoint)(value.display) : '');
  };
};

var boxStyleHelper = /*#__PURE__*/Object.freeze({
  display: display,
  direction: direction,
  alignContent: alignContent,
  alignItems: alignItems,
  alignSelf: alignSelf,
  justifyContent: justifyContent,
  flexGrow: flexGrow,
  flexNone: flexNone,
  flexWrap: flexWrap,
  orderFirst: orderFirst,
  orderLast: orderLast,
  top0: top0,
  right0: right0,
  bottom0: bottom0,
  left0: left0,
  absolute: absolute,
  relative: relative,
  fixed: fixed,
  sticky: sticky,
  overflowHidden: overflowHidden,
  overflowScroll: overflowScroll,
  overflowScrollX: overflowScrollX,
  overflowScrollY: overflowScrollY,
  overflowAuto: overflowAuto,
  fit: fit,
  dangerousStyleValue: dangerousStyleValue,
  height: height,
  minHeight: minHeight,
  maxHeight: maxHeight,
  width: width,
  minWidth: minWidth,
  maxWidth: maxWidth,
  cursor: cursor,
  column: column,
  marginTop: marginTop,
  marginRight: marginRight,
  marginBottom: marginBottom,
  marginLeft: marginLeft,
  paddingX: paddingX,
  paddingY: paddingY,
  border: border,
  borderTop: borderTop,
  borderRight: borderRight,
  borderBottom: borderBottom,
  borderLeft: borderLeft,
  square: square,
  circle: circle,
  pill: pill,
  rounded: rounded,
  roundedTop: roundedTop,
  roundedRight: roundedRight,
  roundedBottom: roundedBottom,
  roundedLeft: roundedLeft,
  noBorder: noBorder,
  breakpointStyle: breakpointStyle
});

/*
Transforms
These are a collection of a few functors that take values and returns
Style's. OMG, I used the word functor - it's really just a fancy word for
function.
*/

/**
 * Adds a style when a property is present
 * <Box top />
 * @param mixin
 */

var toggle = function toggle(mixin) {
  return function (val) {
    return val ? mixin : '';
  };
};
/**
 * Maps string values to styles
 * <Box alignItems="center" />
 * @param map
 */

var mapping = function mapping(map) {
  return function (val) {
    return Object.prototype.hasOwnProperty.call(map, val) ? map[val] : '';
  };
};
/**
 * Maps a range of integers to a range of classnames
 * <Box padding={1} />
 * @param scale
 * @param breakpoint
 */

var range = function range(scale, breakpoint) {
  return function (n) {
    return boxStyleHelper[scale](breakpoint)(n);
  };
};
/**
 * Like `range`, maps a range of integers to a range of classnames, excluding
 * zero values.
 * <Box padding={1} />
 * @param scale
 * @param breakpoint
 */

/**
 * Create a range only if the value is not zero.
 */

var rangeWithoutZero = function rangeWithoutZero(scale, breakpoint) {
  return function (n) {
    return n === 0 ? '' : range(scale, breakpoint)(n);
  };
};
/**
 * This takes a series of the previously defined functors, runs them all against
 * a value and returns the set of their classnames.
 * @param fns
 */

var union = function union() {
  for (var _len = arguments.length, fns = new Array(_len), _key = 0; _key < _len; _key++) {
    fns[_key] = arguments[_key];
  }

  return function (val) {
    return [].concat(fns.map(function (fn) {
      return fn(val);
    }));
  };
};

function _templateObject$6() {
  var data = _taggedTemplateLiteral(["\n  ", ";\n"]);

  _templateObject$6 = function _templateObject() {
    return data;
  };

  return data;
}

var backgroundColor = function backgroundColor() {
  return styled.css(_templateObject$6(), function (_ref) {
    var color = _ref.color;
    return "background-color: ".concat(color, ";");
  });
};

var marginTop$1 = rangeWithoutZero('marginTop');
var marginRight$1 = rangeWithoutZero('marginRight');
var marginBottom$1 = rangeWithoutZero('marginBottom');
var marginLeft$1 = rangeWithoutZero('marginLeft');
var margin = union(marginTop$1, marginBottom$1, marginLeft$1, marginRight$1);
var smMarginTop = rangeWithoutZero('marginTop', 'SM');
var smMarginRight = rangeWithoutZero('marginRight', 'SM');
var smMarginBottom = rangeWithoutZero('marginBottom', 'SM');
var smMarginLeft = rangeWithoutZero('marginLeft', 'SM');
var smMargin = union(smMarginTop, smMarginBottom, smMarginLeft, smMarginRight);
var mdMarginTop = rangeWithoutZero('marginTop', 'MD');
var mdMarginRight = rangeWithoutZero('marginRight', 'MD');
var mdMarginBottom = rangeWithoutZero('marginBottom', 'MD');
var mdMarginLeft = rangeWithoutZero('marginLeft', 'MD');
var mdMargin = union(mdMarginTop, mdMarginBottom, mdMarginLeft, mdMarginRight);
var lgMarginTop = rangeWithoutZero('marginTop', 'LG');
var lgMarginRight = rangeWithoutZero('marginRight', 'LG');
var lgMarginBottom = rangeWithoutZero('marginBottom', 'LG');
var lgMarginLeft = rangeWithoutZero('marginLeft', 'LG');
var lgMargin = union(lgMarginTop, lgMarginBottom, lgMarginLeft, lgMarginRight);
var paddingX$1 = rangeWithoutZero('paddingX');
var paddingY$1 = rangeWithoutZero('paddingY');
var padding = union(paddingX$1, paddingY$1);
var smPaddingX = rangeWithoutZero('paddingX', 'SM');
var smPaddingY = rangeWithoutZero('paddingY', 'SM');
var smPadding = union(smPaddingX, smPaddingY);
var mdPaddingX = rangeWithoutZero('paddingX', 'MD');
var mdPaddingY = rangeWithoutZero('paddingY', 'MD');
var mdPadding = union(mdPaddingX, mdPaddingY);
var lgPaddingX = rangeWithoutZero('paddingX', 'LG');
var lgPaddingY = rangeWithoutZero('paddingY', 'LG');
var lgPadding = union(lgPaddingX, lgPaddingY); // TODO: remove this any

var propToStyleFn = {
  xs: breakpointStyle(),
  sm: breakpointStyle('SM'),
  md: breakpointStyle('MD'),
  lg: breakpointStyle('LG'),
  display: mapping({
    none: display()('none'),
    flex: display()('flex'),
    block: display()('block'),
    inlineBlock: display()('inline-block'),
    inlineFlex: display()('inline-flex')
  }),
  column: column(),
  direction: mapping({
    row: direction()('row'),
    column: direction()('column')
  }),
  smDisplay: mapping({
    none: display('SM')('none'),
    flex: display('SM')('flex'),
    block: display('SM')('block'),
    inlineBlock: display('SM')('inline-block'),
    inlineFlex: display('SM')('inline-flex')
  }),
  smColumn: column('SM'),
  smDirection: mapping({
    row: direction('SM')('row'),
    column: direction('SM')('column')
  }),
  mdDisplay: mapping({
    none: display('MD')('none'),
    flex: display('MD')('flex'),
    block: display('MD')('block'),
    inlineBlock: display('MD')('inline-block'),
    inlineFlex: display('MD')('inline-flex')
  }),
  mdColumn: column('MD'),
  mdDirection: mapping({
    row: direction('MD')('row'),
    column: direction('MD')('column')
  }),
  lgDisplay: mapping({
    none: display('LG')('none'),
    flex: display('LG')('flex'),
    block: display('LG')('block'),
    inlineBlock: display('LG')('inline-block'),
    inlineFlex: display('LG')('inline-flex')
  }),
  lgColumn: column('LG'),
  lgDirection: mapping({
    row: direction('LG')('row'),
    column: direction('LG')('column')
  }),
  alignContent: mapping({
    start: alignContent('flex-start'),
    end: alignContent('flex-end'),
    center: alignContent('center'),
    between: alignContent('space-between'),
    around: alignContent('space-around') // default: stretch

  }),
  alignItems: mapping({
    start: alignItems('flex-start'),
    end: alignItems('flex-end'),
    center: alignItems('center'),
    baseline: alignItems('baseline') // default: stretch

  }),
  alignSelf: mapping({
    start: alignSelf('flex-start'),
    end: alignSelf('flex-end'),
    center: alignSelf('center'),
    baseline: alignSelf('baseline'),
    stretch: alignSelf('stretch') // default: auto

  }),
  bottom: toggle(bottom0),
  color: backgroundColor,
  fit: toggle(fit),
  flex: mapping({
    grow: flexGrow,
    none: flexNone // default: shrink

  }),
  justifyContent: mapping({
    end: justifyContent('flex-end'),
    center: justifyContent('center'),
    between: justifyContent('space-between'),
    around: justifyContent('space-around') // default: start

  }),
  left: toggle(left0),
  cursor: cursor,
  margin: margin,
  marginTop: marginTop$1,
  marginRight: marginRight$1,
  marginBottom: marginBottom$1,
  marginLeft: marginLeft$1,
  smMargin: smMargin,
  smMarginTop: smMarginTop,
  smMarginRight: smMarginRight,
  smMarginBottom: smMarginBottom,
  smMarginLeft: smMarginLeft,
  mdMargin: mdMargin,
  mdMarginTop: mdMarginTop,
  mdMarginRight: mdMarginRight,
  mdMarginBottom: mdMarginBottom,
  mdMarginLeft: mdMarginLeft,
  lgMargin: lgMargin,
  lgMarginTop: lgMarginTop,
  lgMarginRight: lgMarginRight,
  lgMarginBottom: lgMarginBottom,
  lgMarginLeft: lgMarginLeft,
  overflow: mapping({
    hidden: overflowHidden,
    scroll: overflowScroll,
    auto: overflowAuto,
    scrollX: overflowScrollX,
    scrollY: overflowScrollY // default: visible

  }),
  padding: padding,
  paddingX: paddingX$1,
  paddingY: paddingY$1,
  smPadding: smPadding,
  smPaddingX: smPaddingX,
  smPaddingY: smPaddingY,
  mdPadding: mdPadding,
  mdPaddingX: mdPaddingX,
  mdPaddingY: mdPaddingY,
  lgPadding: lgPadding,
  lgPaddingX: lgPaddingX,
  lgPaddingY: lgPaddingY,
  position: mapping({
    absolute: absolute,
    relative: relative,
    fixed: fixed // default: static

  }),
  right: toggle(right0),
  shape: mapping({
    circle: circle,
    pill: pill,
    rounded: rounded,
    roundedBottom: roundedBottom,
    roundedLeft: roundedLeft,
    roundedRight: roundedRight,
    roundedTop: roundedTop // default: square

  }),
  top: toggle(top0),
  flexWrap: toggle(flexWrap),
  height: height,
  minHeight: minHeight,
  maxHeight: maxHeight,
  width: width,
  minWidth: minWidth,
  maxWidth: maxWidth
};

function _templateObject$7() {
  var data = _taggedTemplateLiteral(["\n  box-sizing: border-box;\n  &:focus {\n    outline: 0;\n  }\n  ", ";\n"]);

  _templateObject$7 = function _templateObject() {
    return data;
  };

  return data;
}
// React.HTMLAttributes<HTMLDivElement>

var Box = styled__default.div.attrs({
  'data-id': function dataId(props) {
    return props['data-id'] || 'box';
  },
  style: function style(_ref) {
    var dangerouslySetInlineStyle = _ref.dangerouslySetInlineStyle;
    return dangerouslySetInlineStyle && dangerouslySetInlineStyle.__style ? dangerouslySetInlineStyle.__style : {};
  }
})(_templateObject$7(),
/*
This loops through each property and if it exists in the previously
defined transform map, concatentes the resulting styles. Box's
runtime is only dependent on the number of properties passed to it
(which is typically small) instead of the total number of possible
properties (~30 or so). While it may ~feel~ like Box is
innefficient, its biggest performance impact is on startup time
because there's so much code here.
*/
function (props) {
  var c = [];

  for (var prop in props) {
    if (Object.prototype.hasOwnProperty.call(propToStyleFn, prop)) {
      var fn = propToStyleFn[prop];
      var value = props[prop];
      c = c.concat(fn(value));
    }
  }

  return c;
});

exports.Button = Button;
exports.headShake = headShake;
exports.TextField = TextField;
exports.SelectFieldNative = SelectFieldNative;
exports.RadioGroupFieldInner = RadioGroupFieldInner;
exports.handlers = handlers;
exports.enhance = enhance;
exports.RadioGroupField = RadioGroupField;
exports.Radio = Radio;
exports.Box = Box;
//# sourceMappingURL=ff-atoms.cjs.development.js.map
